<div class="diversity-button selectable">
  <img src={urlFor(`hand_${shape}_${color}`)}
       alt="Toggle Diversity Picker"
       on:click="set({open: !open})"
       class="hand-button" />
</div>

{#if open}
<div class="diversity-picker">
  <div class="colors">
    {#each allColors as currentColor (currentColor)}
    <div class="color"
         on:click="setColor(currentColor, shape)">
      <img src={urlFor(`color_modifier_${currentColor}`)}
           alt={currentColor}
           class:hide="isDisabled(shape, currentColor)"
           class:selected="color == currentColor"
           class="color-emoji selectable" />
    </div>
    {/each}
  </div>
  
  <div class="shapes">
    {#each shapes as currentShape (currentShape)}
    <div class="shape"
         on:click="setShape(currentShape, color)">
      <img src={urlFor(`${currentShape == "clw" ? "claw" : currentShape}_hand_modifier`)}
      alt={currentShape}
           class:selected="currentShape == shape"
           class="shape-emoji selectable" />
    </div>
    {/each}
  </div>
</div>
{/if}

<script>
  import EmojiUtils from "../js/EmojiUtils.js";
  import * as Emoji from "../js/emojis";

  function isDisabled(shape, color) {
    return Emoji.colorOverrides[color] && Emoji.colorOverrides[color] != shape;
  }
  
  export default {
    data() {
      return {
        shapes: Emoji.shapes,
        allColors: Emoji.allColors
      };
    },
    helpers: {
      urlFor: EmojiUtils.urlFor,
      isDisabled
    },
    methods: {
      setShape(shape, color) {
        const diff = {shape};
        const storeDiff = {emojiShape: shape};
        if (isDisabled(shape, color)) {
          diff.color = "k2";
          storeDiff.emojiColor = "k2";
          localStorage.emojiColor = "k2";
        }
        this.set(diff);
        this.store.set(storeDiff);
        localStorage.emojiShape = shape;
      },
      setColor(color, shape) {
        if (isDisabled(shape, color)) return;
        this.set({color});
        this.store.set({emojiColor: color});
        localStorage.emojiColor = color;
      }
    }
  };
</script>

<style>
  .diversity-button {
    cursor: pointer;
    display: inline-block;
    padding: 0.2em;
    margin: 0.3em;
    margin-right: 0.5em;
  }

  .selectable:hover,
  .selectable.selected {
    background: #4b4f52;
  }

  .selectable {
    cursor: pointer;
    border-radius: 2px;
  }

  .diversity-button,
  .hand-button {
    height: 1.5em;
    width: 1.5em;
    position: relative;
  }

  .diversity-picker {
    z-index: 1;
    box-shadow: 0 2px 3px #1112;
    border-radius: 3px;
    right: 0;
    position: absolute;
    display: flex;
    flex-direction: column;
    background: #2a2a2a;
    border: solid 1.4px #222;
    width: 9em;
    height: 14em;
  }

  .colors {
    flex-grow: 1;
    flex-shrink: 1;
    overflow: auto;
  }

  .color {
    display: inline-block;
  }

  /*.color {
    height: 1.5em;
    width: 1.5em;
  }*/

  .shapes {
    border-top: #202020 solid 1.4px;
    padding: 0.1em 0;
    height: 2em;
    flex-grow: 0;
    flex-shrink: 0;
    display: flex;
    flex-direction: row;
  }

  .shape {
    flex-grow: 1;
    margin: auto;
    text-align: center;
    display: inline-block;
  }

  .color-emoji,
  .shape-emoji {
    height: 1.5em;
    width: 1.5em;
    padding: 0.125em;
    margin: 0.125em;
  }

  .hide {
    cursor: not-allowed;
    filter: grayscale(35%);
    opacity: 0.5;
  }

  .hide:hover {
    background: none;
  }
</style>
